// dc-file.c

// 2003 bero

#include "egoboo.h"
#include <kos/fs.h>

//---------------------------------------------------------------------------------------------
//File Routines-------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------

// Had to revert back to prog x code to prevent import/skin bug

void make_directory(char *dirname)
{
    // ZZ> This function makes a new directory
    fs_mkdir(dirname);
}

//---------------------------------------------------------------------------------------------
void remove_directory(char *dirname)
{
    // ZZ> This function removes a directory
    fs_unlink(dirname);
}

//---------------------------------------------------------------------------------------------
void delete_file(char *filename)
{
    // ZZ> This function deletes a file
    fs_unlink(filename);
}

//---------------------------------------------------------------------------------------------
void copy_file(char *source, char *dest)
{
    // ZZ> This function copies a file on the local machine
    FILE* fileread;
    FILE* filewrite;
    char buf[2048];


    fileread = fopen(source, "rb");
    if(fileread)
    {
        filewrite = fopen(dest, "wb");
        if(filewrite)
        {
            size_t rsize;
            while((rsize=fread(buf,1,sizeof(buf),fileread))!=0)
            {
                fwrite(buf,1,rsize,filewrite);
            }
            fclose(filewrite);
        }
        fclose(fileread);
    }
}

//---------------------------------------------------------------------------------------------
void delete_directory(char *dirname)
{
    // ZZ> This function deletes all files in a directory,
    //     and the directory itself
    char filename[128];

    // Search for all files
    file_t hnd = fs_open(dirname,O_RDONLY|O_DIR);
    dirent_t *ent;
    if (hnd==0) return;
    while(ent=fs_readdir(hnd)) {
         if (strcmp(ent->name,".")==0 || strcmp(ent->name,"..")==0) continue;
         sprintf(filename,"%s/%s",dirname,ent->name);
         delete_file(filename);
    }
    fs_close(hnd);
    remove_directory(dirname);
}

//---------------------------------------------------------------------------------------------
void copy_directory(char *dirname, char *todirname)
{
    // ZZ> This function copies all files in a directory
    char fromname[128];
    char toname[128];

    // Search for all files
    file_t hnd = fs_open(dirname,O_RDONLY|O_DIR);
    dirent_t *ent;
    if (hnd==0) return;
    while(ent=fs_readdir(hnd)) {
         if (strcmp(ent->name,".")==0 || strcmp(ent->name,"..")==0) continue;
         sprintf(fromname, "%s/%s", dirname, ent->name);
         sprintf(toname, "%s/%s", todirname, ent->name);
         copy_file(fromname, toname);
    }
    fs_close(hnd);
}

//---------------------------------------------------------------------------------------------
void empty_import_directory(void)
{
    // ZZ> This function deletes all the TEMP????.OBJ subdirectories in the IMPORT directory
    int cnt;
    char filename[256];

    cnt = 0;
    while(cnt < MAXIMPORT)
    {
        sprintf(filename, "import/temp%04d.obj", cnt);
        delete_directory(filename);
        cnt++;
    }
}


//---------------------------------------------------------------------------------------------
//Directory Functions--------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------
static file_t dirhnd;
static char ext[16];
//---------------------------------------------------------------------------------------------
// Read the first directory entry
char *DirGetFirst(char *search)
{
/* *.obj/*.mod */
	char dirname[256];
	char *p;

//printf("DirGetFirst:%s\n",search);
	strcpy(dirname,search);
	p = strrchr(dirname,'/');
	if (p) {
		*p++=0;
	} else {
		// assert(0);
	}
	p = strrchr(p,'.');
	strcpy(ext,p);
	dirhnd = fs_open(dirname,O_RDONLY|O_DIR);
	if (dirhnd==0) return NULL;
	return DirGetNext();
}

//---------------------------------------------------------------------------------------------
// Read the next directory entry (NULL if done)
char *DirGetNext(void)
{
	dirent_t *ent;
	while(ent = fs_readdir(dirhnd)) {
		char *p = strrchr(ent->name,'.');
//	printf("readdir:%s\n",ent->name);

		if (p!=NULL && stricmp(p,ext)==0) {
//	printf("DirGetNext:%s\n",ent->name);
			return ent->name;
		}
	}
//	printf("DirGetNext:NULL\n");
	return NULL;
}

//---------------------------------------------------------------------------------------------
// Close anything left open
void DirClose()
{
//	printf("DirClose:\n");
	fs_close(dirhnd);
	dirhnd = 0;
}

/* 
	jif =  ms * HZ /1000
	ms  = jif * 1000/HZ
*/

#include <kos.h>
static unsigned start;

int ClockGetTick()
{

printf("%d ",CLOCKS_PER_SEC);

	if (start==0) start = jiffies;
	return (jiffies-start)*((float)CLOCKS_PER_SEC/HZ);

//	return SDL_GetTicks()*(CLOCKS_PER_SEC/1000); /* ms */
//	clock() don't support kos 
// 	return(clock());
}

int DirGetAttrib(char *fromdir)
{
  return 0; //(GetFileAttributes(fromdir));
}
